package downloader; 

######################## Inportant note. ###########################
# If running this script on a Unix machine, it is recommended that #
# a -T be placed after the path to perl on the first line. like so:#
# #!/usr/bin/perl -T                                               #
# This will put the script into "Taint" mode, which is a very good #
# practice for cgi-scripts. Windows users should ask their system  #
# Administrator for the file extension required or Taint mode perl.#
####################################################################
####################################################################
#         HTMLfixIT File Download controller and counter.          #
#                       http://htmlfixit.com                       #
#      Usage:                                                      #
#      Keeps track of the number of times a file is downloaded     #
#      And initiates the download as well as displaying a          #
#      download count for pages using SSI or PHP (using the PHP    #
#      addon script.)                                              #
#                       Copyright Frank Hauptle.                   #
#                         All rights reserved.                     #
#                            Version 0.9                           #
#                        RC1, 23 May 2003                          #
#         Please report any bugs to franki@htmlfixit.com           #
####################################################################
####################################################################
#                      THE USUAL DISCLAIMER.                       #
# This software is provided by the copyright holders and           #
# contributors `as is' and any express or implied warranties,      #
# including, but not limited to, the implied warranties of         #
# merchantability and fitness for a particular purpose are         #
# disclaimed.                                                      #
# In no event shall the author or contributors be liable for any   #
# direct, indirect, incidental, special, exemplary,or consequential#
# damages (including, but not limited to, procurement of substitute#
# goods or services; loss of use, data, or profits; or business    #
# interruption) however caused and on any theory of liability,     #
# whether in contract, strict liability, or tort (including        #
# negligence or otherwise)  arising in any way out of the use of   #
# this software, even if advised of the possibility of such damage.#
#                                                                  #
# This software is distributed under the same terms as perl itself.#
####################################################################
# IMPORTANT NOTE: Filenames must ONLY contain the following:       #
# alphanumerics, dots, dashes and underscores.                     #
#  They MUST also start with a word. eg filename-123.tar.gz        #
####################################################################
# To display a file count insert this in your page:                #
# (edit filename to suit)                                          #
#<!--#include virtual='/cgi-bin/download.pl?function=count&id=stats-counter-0.9.zip' -->
#                                                                  #
# To insert the downloader link, insert this into your page in a   #
# href link. (edit filename to suit)                               #
# <a href="/cgi-bin/download.pl?file=stats-counter-0.9.tar.gz">    #
sub run {
####################################################################
#                    Configuration Settings.                       #
####################################################################
       # All config for this script is in the seperate downloader_config.pl
       # file, for unix hosts, no modifications are necessary here.
       # For windows hosts, the two variables below should be changed
       # to the directory path that the script will reside in on the server.
       # for example: $path_to_lib = 'c:/Inetpub/Scripts/downloads';
       # DO NOT add a trailing / to the end.

my $path_to_lib    = '.';  
my $path_to_config = '.';

###################################################################

require "$path_to_lib/htmlfixit-lib.pl";
require "$path_to_lib/downloader_config.pl";

use CGI qw(:standard);
use CGI::Cookie;
      # Some security stuff.
$CGI::DISABLE_UPLOADS = 1;
$CGI::POST_MAX        = 512 * 1024;

# If $demo is 1, then assume demo mode, fill in the login fields, and disable the reset feature.
# if $demo is 0, assume normal operation.
my $demo           = 0;

       # Get the configuration values.
my ($user_name, 
    $pass_word, 
    $counterfiledir, 
    $download_url, 
    $domain, 
    $path, 
    $expiration,
    $tmp_dir
    ) = downloader_config::config();

my $query = new CGI;
my ($login_status, $login_message, $session) = htmlfixit::login_code($query, 'dl_admin', 'username', 
                                                             'password', 'login',  
                                                             $user_name, $pass_word, 
                                                             'id', $tmp_dir,$domain, 
                                                             $path, $expiration);

if    ($login_status == 0){htmlfixit::not_specified_error(); goto _end;}
elsif ($login_status == 1){&display_downloads($query,$counterfiledir,'dl_admin',$domain,$path,$session,$tmp_dir, $demo); goto _end;}
elsif ($login_status == 2){htmlfixit::display_login('Downloader', 'dl.pl', 'login=yes', $login_message,$demo,$user_name,$pass_word); goto _end;}
elsif ($login_status == 3){htmlfixit::display_login('Downloader', 'dl.pl', 'login=yes', $login_message,$demo,$user_name,$pass_word); goto _end;}
elsif ($login_status == 4){what_to_do($query, $counterfiledir, $download_url); goto _end;}
else {goto _end;}
# Create a label to send script to end.
_end:
} # End of sub run.
###################################################################
sub what_to_do
{
my $query            = shift;
my $counterfiledir   = shift;
my $download_url     = shift;

# Get the query data and assign to variables.
my $id = $query->param('id') || 'not available';
my $function = $query->param('function') || 'download';

my $download;
if ($id =~ m|^([\w\-\.]*)$|i)
     {$download = $1;}
else {$download = 'not_available';}

my $file_and_path_dl = $download_url . $download;
   
   # For the counter text file.
my $download2 = $download . '.txt';
my $file_and_path_count = $counterfiledir.'/'.$download2;

# Define the programs logic.
if     (($function eq 'count') && ($id ne 'not available'))
       {
       my $count = read_count($file_and_path_count);
       print "Content-type: text/html\n\n";
       print $count;
       }
elsif (($function eq 'download') && ($id ne 'not available'))
       {
       my $update_status = downloader($file_and_path_dl, $file_and_path_count);
       unless ($update_status == 1)
        {
        print "Content-type: text/html\n\n";
        print "<html><body>Problem updating the download counter.</body></html>\n";
        goto _end;
        } 
        # All done, so give them the file.
       print "location: $file_and_path_dl\n\n";
       }
else
    {
    print "Content-type: text/html\n\n";
    print "<html><body>I do not understand what you want or the file you requested cannot be supplied</body></html>\n";
    }
} #End of function determination code.

###################################################################
sub display_downloads
{
my $query          = shift;
my $counterfiledir = shift;
my $cookie_id      = shift;
my $domain         = shift;
my $path           = shift;
my $session        = shift;
my $tmp_dir        = shift;
my $demo           = shift;
my $voting         = 1;


my $dirty_reset = $query->param('fileset') || '';
# Make sure $reset is not passed nasty chars.
if ($dirty_reset =~ m/^([\-\.\w]*)$/i)
{$reset = $1;}

unless ($reset eq '')
{
   my $reset_file = $counterfiledir.'/'.$reset.'.txt'; 
   if (-e $reset_file)
   {unlink $reset_file or die "can't delete $reset_file reason $!";}
}

my $css = htmlfixit::display_css();
my $odd = "<tr class='odd'>";
my $evn = "<tr class='evn'>";
my $tr_color    = '';
my $countno     = 1;
my $vote_output = htmlfixit::voting('\'Download counter\'', 'http://htmlfixit.com/vote.php#down_counter');  

print "Content-type: text/html\n\n";
print '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">'."\n";

print "<html><head><title>Download counts</title></head>\n";
print "<meta http-equiv='Cache-Control' content='no-store' />\n";
print "<meta http-equiv='pragma' content='no cache' />\n";
print "<meta http-equiv='Expires' content='0' />\n";
print $css."\n<body><br />\n";


print '<div align=\'center\' id=\'title\' class=\'content\'><br /><span align=\'center\' class=\'heading\'><a href=\'http://HTMLfixIT.com\' target=\'_blank\'>HTMLfixIT.com</a>'."\n";
print 'Download counter summary.</span><br /><p align=\'right\'><b>[<a href=\'dl.pl?login=yes\'>refresh counts</a>]&nbsp;::&nbsp;[<a href=\'dl.pl?login=yes&logout=yes\'>logout</a>]</b>&nbsp;&nbsp;&nbsp;&nbsp;</p></div>'."\n";
print $vote_output if ($voting == 1);
print '<br /><div align=\'center\' class=\'content\'><br />'."\n".'<table width=\'525px\' class=\'cont\' border=\'0\' cellpadding=\'3\' cellspacing=\'0\' align=\'center\'><tr><th colspan=\'4\'>Your download counts:</th></tr>'."\n";

opendir(DOWNLOADS,"$counterfiledir")|| die "Can't open $counterfiledir Reason: $!";
my @counterfiles = sort(grep(/\.[0-9, a-z, A-Z]/,readdir(DOWNLOADS)));
closedir(DOWNLOADS) || die "Can't close $counterfiledir Reason: $!";

foreach(@counterfiles){
my $file_and_path_count = $counterfiledir .'/' . $_;

#my $creation = (stat("$file_and_path_count"))[10];
#   $creation = scalar localtime $creation;

open(COUNT,"$file_and_path_count")|| die "Can't open $file_and_path_count Reason: $!";
flock(COUNT, 1) or die"cannot lock $file_and_path_count Reason: $!";
my $count = <COUNT>;
flock(COUNT, 8);
close(COUNT); 
$_ =~ s/\.txt$//;
$tr_color = ($countno % 2) ? $odd : $evn;
my $js_reset;

if ($demo==1)
{
$js_reset = qq{
[<a href='dl.pl?login=yes' onclick='javascript:
     var message= "This feature will remove a counter file for a particular download so it will reset to \\"1\\" on the next download. ";
     message+="\\nThe feature has been disabled in when in demo mode.";
     if(confirm(message)){document.location="dl.pl?login=yes"}else{return false};'>reset</a>]
};}
else{
$js_reset = qq{
[<a href='dl.pl?login=yes&fileset=$_' onclick='javascript:
     var message= "Are you sure you want to reset the $_ file count?";
     message+="\\nIf you do, $_ will be removed from the display summary until it is downloaded again.";
     if(confirm(message)){document.location="dl.pl?login=yes&fileset=$_"}else{return false};'>reset</a>]
};}

my $tables = qq{
$tr_color 
   <td align='left'> $_ </td>
   <td align='left'> &nbsp;downloads:</td> 
   <td align='right'>$count           </td>
   <td>&nbsp;&nbsp;$js_reset
   </td>
</tr>
};
print $tables;
$countno++;
}
print '</table>';
print '<br /></div>'."\n".'</body></html>';
}

###################################################################
# usage my $output_count = read_count($file_and_path_count);
sub read_count
{
my $file_and_path_count = shift;
my $count = 'nothing';
if (-f $file_and_path_count)
{
open(COUNT,"$file_and_path_count")|| die "Can't open $file_and_path_count Reason: $!";
flock(COUNT, 1) or die"cannot lock $file_and_path_count Reason: $!";
$count = <COUNT>;
flock(COUNT, 8);
close(COUNT); 
}
else 
{
open(COUNT,">$file_and_path_count")|| die "Can't open $file_and_path_count Reason: $!";
flock(COUNT, 2) or die"cannot lock $file_and_path_count Reason: $!";
print COUNT "0";
flock(COUNT, 8);
close(COUNT); 
}

$count = 0 if (($count eq 'nothing') or ($count eq ''));
return $count;
}

###################################################################
# usage my $outputfile = downloader($file_and_path_dl, $file_and_path_count;
sub downloader
{
my ($file_and_path_dl, $file_and_path_count) = @_;
my $countnumber = '';
if (-f $file_and_path_count)
{
open(COUNTER,"$file_and_path_count") || die "Can't open $file_and_path_count Reason: $!";
flock(COUNTER, 1) or die "cannot lock $file_and_path_count Reason: $!";
$countnumber = <COUNTER>;
flock(COUNTER, 8);
close(COUNTER);
}

$countnumber = 0 if $countnumber eq '';
$countnumber += 1;

open(WRITECOUNTER,">$file_and_path_count") || die "Can't open $file_and_path_count Reason: $!";
flock(WRITECOUNTER, 2) or die "cannot lock $file_and_path_count $!";
print WRITECOUNTER "$countnumber";
flock(WRITECOUNTER, 8);
close(WRITECOUNTER); 

return 1; 
}
###################################################################
1;
__END__